/* CS 472/672 Assignment #2 - matrhs.c file */

#include <stdlib.h>
#include <math.h>
#include "matrhs.h"


/*
  imgmatrix creates the matrix for the denoising iteration.
*/
void imgmatrix(int n,double alpha,int *ia,int *ja,double *a)
{
  int i,j,k,I;

  ia[0] = 0;
  k = 0;
  for (j=0; j<n; j++) {
    for (i=0; i<n; i++) {

      I = j*n+i;

      /* bottom */
      if (j>0) {
        ja[k] = I-n; a[k] = -(n+1)*(n+1)*alpha; k++;
      }

      /* left */
      if (i>0) {
        ja[k] = I-1; a[k] = -(n+1)*(n+1)*alpha; k++;
      }

      /* center */
      ja[k] = I; a[k] = 4*(n+1)*(n+1)*alpha+1.0; k++;

      /* right */
      if (i<n-1) {
        ja[k] = I+1; a[k] = -(n+1)*(n+1)*alpha; k++;
      }

      /* top */
      if (j<n-1) {
        ja[k] = I+n; a[k] = -(n+1)*(n+1)*alpha; k++;
      }

      ia[I+1] = k;
    }
  }

}


/*
  noisyimg creates a noisy image and stores the pixel values
  to the vector b.
*/
void noisyimg(int n,double *b)
{
  int    i,j,I,N;
  double h,x,y,r1,r2,b_norm;

  h=1.0/(n+1);
  for (j=1; j<=n; j++) {
    for (i=1; i<=n; i++) {

      I=(j-1)*n+i-1;

      /* exact image value */
      x=i*h; y=j*h;
      r1=sqrt((x-0.5)*(x-0.5)+(y-0.5)*(y-0.5));
      r2=sqrt((x-0.5)*(x-0.5)/2+(y-0.5)*(y-0.5));
      b[I]=0.0;
      if (r1<0.2) b[I] -= 0.5;
      if (r2<0.3) b[I] += 1.0;

    }
  }

  /* Add noise to b */
  b_norm=0.0;
  N=n*n;
  for (i=0; i<N; i++) b_norm += b[i]*b[i];
  b_norm=sqrt(b_norm);
  srand(42);
  for (i=0; i<N; i++) b[i] += 2*h*b_norm*(2.0*rand()/RAND_MAX-1);

}

